-- -------------------------------------------------------
-- Quick "old skool" Raster / Copper bar demo!
-- Jon Howard (jon@whitetreegames.com / www.whitetreegames.com)
-- -------------------------------------------------------

application:setBackgroundColor(0)
WIDTH = application:getContentWidth()
HEIGHT = application:getContentHeight()
centerY = HEIGHT * 0.5

barImg = Texture.new("bar.png")

numBars = 10
barOffsetScale = 2
barHeightScale = 1

iI = 1 / numBars

bars = { }

for i=1,numBars do
	bars[i] = Bitmap.new(barImg)
	bars[i]:setScaleX(WIDTH)
	bars[i]:setScaleY(barHeightScale)
	bars[i]:setAnchorPoint(0,0.5)
	stage:addChild(bars[i])
end

function loop(event)
	local t = os.timer() 
	local y,ni,r,g,b 

	ni = 0
	for i=1,numBars do
		
		-- Bounce the bars on sine wave (driven by os.timer)
		y = centerY + (centerY * math.cos(t + (ni * barOffsetScale)))
		bars[i]:setY(y)
	
		-- Dynamically adjust the colour
		r = (192 + (64 * math.sin(t*3.7+ni*1.3))) / 256
		g = (192 + (64 * math.sin(t*3.7+ni*4.2))) / 256
		b = (192 + (64 * math.cos(t*3.7+ni*3.7))) / 256
		
		bars[i]:setColorTransform(r,g,b,1)
		
		ni = ni + iI
	end
end

stage:addEventListener(Event.ENTER_FRAME,loop)

--[[
-- -------------------------------------------------------------------------
-- local methods required to put an FPS counter on the screen...

local frame = 0
local timer = os.timer()
local qFloor = math.floor
local fps	

-- -------------------------------------------------------------------------

local function updateFPS(self,e)
	frame = frame + 1
	if frame == 60 then
		local currentTimer = os.timer()
		fps:setText(""..qFloor(60 / (currentTimer - timer)))
		local width = fps:getWidth()
		fps:setPosition(WIDTH-(width+10), 28)	--HEIGHT-10)
		frame = 0; timer = currentTimer	
	end
end

-- -------------------------------------------------------------------------

local function initFPS(group)
	fps = TextField.new(nil,"")
	fps:setTextColor(0x00FFFF)
	fps:setScale(3,3)
	fps:addEventListener(Event.ENTER_FRAME,updateFPS,nil)
	group:addChild(fps)
end

initFPS(stage)	-- Add a quick FPS counter on the screen (REMOVE for final build)
--]]

-- End of file...